###########################################################################
#
# win32 makefile -- gssetup
# A component of the Greenstone digital library software
# from the New Zealand Digital Library Project at the
# University of Waikato, New Zealand.
#
# Copyright (C) 2006 The New Zealand Digital Library Project
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################

CC = cl
CPPFLAGS = -GX
DEFS = -DGSDL_NAMESPACE_BROKEN -D__STL_NO_NEW_IOSTREAMS
INCLUDES = -I"C:\mdewsnip\gsdl-cvs.new\packages\windows\stlport\stlport"

COMPILE = $(CC) -nologo -c $(CPPFLAGS) $(DEFS) $(INCLUDES)
LINK = $(CC) -nologo

WINLIBS = advapi32.lib comctl32.lib comdlg32.lib gdi32.lib \
          ole32.lib shell32.lib user32.lib uuid.lib

.SUFFIXES:
.SUFFIXES: .cpp .obj
.cpp.obj:
	$(COMPILE) $< 

GSSETUP_OBJECTS = \
  configFile.obj configurable.obj copyProgress.obj dirent.obj dirSelector.obj DiskSpace.obj file.obj fileCopier.obj FilePath.obj gsinstall.obj gsManifest.obj gsPlatform.obj gsProfile.obj gsProgman.obj gsRegistry.obj launchApp.obj registry.obj stringArray.obj unInstall.obj gssetup.res

all: gssetup.exe

gssetup.exe: $(GSSETUP_OBJECTS)
	if EXIST gssetup.exe del gssetup.exe
	$(LINK) -o gssetup.exe $(GSSETUP_OBJECTS) $(WINLIBS)

gssetup.res: vcinstall.rc vcinstall.bmp
	rc /fo "gssetup.res" "vcinstall.rc"

clean:
	del *.obj
	del gssetup.exe

install:
